import javafx.scene.image.Image;

public class FireSprite extends ActorSprite
{
	TreeSprite tree;
	Image smokeImage;

	static final int PERSISTENCE = 20;

	FireSprite(double x1, double y1, Sprite s[], TreeSprite t, Image i, Image si)
	{
		super(x1, y1, s, i);
		tree = t;
		smokeImage = si;
		speed = 7.0;
	}

	public void updateSprite()
	{
		if (!active)
			return;
		counter--;
		if (alive)
		{
			if (counter <= 0)
			{
				// Reset velocity
				headTo(tree.getX(), tree.getY());
				counter = PERSISTENCE;
			}
			updatePosition();
			for (int i = 0; i < scenery.length; i++)
			{
				if (collision(scenery[i]))
				{
					// The fire is quenched by water
					if (scenery[i] instanceof LakeSprite)
					{
						setVelocity(0.0, 0.0);
						alive = false;
						image = smokeImage;
						counter = BigForest.DYING;
					}
					else
					{
						// Hit something solid, back up and stop
						x -= dx; y -= dy;
						setVelocity(0.0, 0.0);
					}
				}
			}
			// Check the tree
			if (collision(tree))
			{
				tree.burn();
				suspend();
			}
		}
		else
		{
			// We're quenched - wait a bit, then go away
			if (counter <= 0)
				suspend();
		}
	}
}

