import javafx.scene.image.Image;

public class TreeSprite extends ActorSprite
{
	Image burnImage;

	TreeSprite(int x1, int y1, Sprite s[], Image i, Image bi)
	{
		super(x1, y1, s, i);
		burnImage = bi;
		speed = 5.0;
	}

	public void updateSprite()
	{
		if (!active)
			return;
		if (alive)
		{
			updatePosition();
			for (int i = 0; i < scenery.length; i++)
			{
				if (collision(scenery[i]))
				{
					// The tree is wood, hence floats on water
					if (scenery[i] instanceof LakeSprite)
						continue;
					// Hit something solid, back up and stop
					x -= dx; y -= dy;
					setVelocity(0.0, 0.0);
				}
			}
		}
		else
		{
			// We're on fire - wait a bit, then go away
			counter--;
			if (counter <= 0)
				suspend();
		}
	}

	public void burn()
	{
		setVelocity(0.0, 0.0);
		alive = false;
		image = burnImage;
		counter = BigForest.DYING;
	}
}
